#ifndef lint
static char *RCSid = "$Header: shi.c,v 1.1 89/12/14 08:20:51 jay Exp $";
#endif /* not lint */

/*
 * aboa.c - report what tanks/planes are aboard one or more ships
 *
 * from PSL Empire, 1985
 */

#include "misc.h"
#include "var.h"
#include "xy.h"
#include "sect.h"
#include "ship.h"
#include "plane.h"
#include "nuke.h"
#include "nat.h"
#include "nsc.h"
#include "deity.h"
#include "file.h"

#define padding	20
#define CLASS_PLANE 99	/* arbitrary unused class */

typedef struct {
    natid own;
    short aboard,id;
    char typ,vehtype,effic,mobil;
    int nukeamt,nuketype;
} vehicle;

aboa()
{
    extern char *argp[];
    int	ntanks,nplanes,nships,nv,i,j;
    struct nstr_item ni;
    struct shpstr ship;
    struct plnstr plane;
    char *s;
    vehicle *v,*vp;
   
    nv = 0;

    /* count up ships/tanks/balloons/etc */
    if (!snxtitem(&ni, EF_SHIP, "*")) return RET_SYN;
    while (nxtitem(&ni, (char *)&ship)) {
	if (ship.shp_own && ship.shp_type>=0 && ship.shp_type<=shp_maxno)
	    nv++;
    }

    /* count up planes */
    if (!snxtitem(&ni, EF_PLANE, "*")) return RET_SYN;
    while (nxtitem(&ni, (char *)&plane)) {
	if (plane.pln_own) nv++;
    }

    /* allocate a big buffer for all this stuff */
    v = (vehicle *)calloc(nv+padding,sizeof(vehicle));
    vp = v;
    nv = 0;

    /* get info about all those ships/tanks/balloons/etc */
    snxtitem(&ni, EF_SHIP, "*");
    while (nxtitem(&ni, (char *)&ship)) {
	if (ship.shp_own && ship.shp_type>=0 && ship.shp_type<=shp_maxno) {
	    vp->id = ni.cur;
	    vp->aboard = ship.shp_aboard;
	    vp->typ = ship.shp_type;
	    vp->own = ship.shp_own;
	    vp->vehtype = vehicleclass(&ship);
	    vp->effic = ship.shp_effic;
	    vp->mobil = ship.shp_mobil;
	    vp++; nv++;
	}
    }

    /* get info about all those planes */
    snxtitem(&ni, EF_PLANE, "*");
    while (nxtitem(&ni, (char *)&plane)) {
	if (plane.pln_own) {
	    vp->id = ni.cur;
	    vp->aboard = plane.pln_ship;
	    vp->typ = plane.pln_type;
	    vp->own = plane.pln_own;
	    vp->vehtype = CLASS_PLANE;
	    vp->effic = plane.pln_effic;
	    vp->mobil = plane.pln_mobil;
	    vp->nukeamt = plane.pln_nukeamt;
	    vp->nuketype = plane.pln_nuketype;
	    vp++; nv++;
	}
    }

    nships = 0;
    if (!snxtitem(&ni, EF_SHIP, argp[1])) return RET_SYN;
    while (nxtitem(&ni, (char *)&ship)) {
	if (!ship.shp_own) continue;
	if (!(god || ship.shp_own==cnum)) continue;
	if (!mchr[ship.shp_type].m_maxplns &&
	    !mchr[ship.shp_type].m_maxtnks) continue;
	vp = v;
	for (nplanes=ntanks=j=0; j<nv; j++) {
	    if (vp->aboard==ni.cur) {
		if (nplanes+ntanks == 0) {
		    pr("\n");
		    if (!nships) {
			if (god) pr("own ");
			pr("   # transport type      ");
			pr("x,y      eff mob    # item\n");
		    }
		    if (god) pr(fmt("%3d ",ship.shp_own));
		    pr(fmt("%4d %-16.16s ",
			   ni.cur,mchr[ship.shp_type].m_name));
		    pr(fmt("%s ",
			   xyfmt("%4d,%-4d", ship.shp_x,ship.shp_y, cnum)));
		} else {
		    if (god) pr("    ");
		    pr(fmt("%-32.32s",""));
		}
		if (ship.shp_own != vp->own) pr(fmt("%s ",cname(vp->own)));
		switch (vp->vehtype) {
		case CLASS_PLANE:
		    pr(fmt("%4d%% %3d %4d %s",
			   vp->effic,vp->mobil,vp->id,
			   plchr[vp->typ].pl_name));
		    if (vp->nukeamt > 0)
			pr(fmt(" (%d %s)",
			       vp->nukeamt,nchr[vp->nuketype].n_name));
		    pr("\n");
		    nplanes++;
		    break;
		default:
		    pr(fmt("%4d%% %3d %4d %s\n",
			   vp->effic,vp->mobil,vp->id,mchr[vp->typ].m_name));
		    ntanks++;
		    break;
		}
	    }
	    vp++;
	}
	/* Take this opportunity to insure these values are correct */
	ship.shp_ntank = ntanks;
	ship.shp_nplane = nplanes;
	putship(ni.cur,&ship);
	if (nplanes || ntanks) nships++;
    }

    free(v);
    if (nships) {
	pr(fmt("%d ships/vehicles\n",nships));
    }
    return RET_OK;
}
