/*
**  bid.c
**
**  Set ask/bid prices on trade center commodities
**
**  Bill Frolik, 1990
*/

#include "misc.h"
#include "xy.h"
#include "file.h"
#include "var.h"
#include "sect.h"
#include "item.h"
#include "nsc.h"
#include "nat.h"
#include "nuke.h"
#include "plane.h"
#include "ship.h"
#include "trade.h"
#include "deity.h"

#ifdef TRADECENTERS

#include "shop.h"

ask()	{ return (tcsetprice(0)); }
bid()	{ return (tcsetprice(1)); }

tcsetprice(setbuy)
int setbuy;
{
    extern char *argp[];
    struct sctstr sect;
    struct nstr_sect nstr;
    struct ichrstr *ip;
    tradecenter shop;
    int i,n,product,thresh,setprice;
    char *p,*action;
    float price;

    action = setbuy ? "buy" : "sell";
    ip = whatitem(argp[1],fmt("Set %sing price of what commodity : ",
			      action));
    if (!ip) return RET_SYN;
    if (ip->i_sell == 0) {
	pr(fmt("You can't %s %s\n",action,ip->i_name));
	return RET_FAIL;
    }

    product = ip - ichr;
    if (!snxtsct(&nstr, argp[2])) return RET_SYN;

    p = getstarg(argp[3],"price : ");
    if (!p || !*p || *p=='.') setprice = 0;
    else {
	setprice = 1;
	price = atof(p);
	if (price <= 0.0) {
	    pr("Withdrawing commodity from market.\n");
	    price = -1.0;
	}
    }

    thresh = -1;
    if (p=getstarg(argp[4],fmt("%s qty threshold : ",setbuy?"buy":"sell")))
	thresh = atoi(p);

    if (!setprice && thresh<0) {
	pr("No price or threshold changes requested.\n");
	return RET_FAIL;
    }

    for (n=0; nxtsct(&nstr,&sect); ) {
	if ((!owner && !god) || (sect.sct_type != SCT_TRADE)) continue;
	if (sect.sct_newtype != SCT_TRADE) {
	    pr(fmt("%s dismantling, cannot set prices/thresholds\n",
		   xyas(sect.sct_x,sect.sct_y,cnum)));
	    continue;
	}
	lockshop();
	if (!getshop(sect.sct_x,sect.sct_y,&shop))
	    if (!setupshop(sect.sct_x,sect.sct_y,&shop)) {
		unlockshop();
		pr("Can't setup new trade center; get help!\n");
		logerror(fmt("tcsetprice: setupshop @ %d,%d failed",
			     sect.sct_x,sect.sct_y));
		return RET_SYS;
	    }
	if (setbuy) {
	    if (setprice) shop.item[product].buyprice = price;
	    if (thresh>=0) shop.item[product].hiwater = thresh;
	}
	else {
	    if (setprice) shop.item[product].sellprice = price;
	    if (thresh>=0) shop.item[product].lowater = thresh;
	}
	shopwrite(&shop,-1);
	unlockshop();
    }
    return RET_OK;
}

#else

ask() { return RET_SYN; }
bid() { return RET_SYN; }

#endif
