#ifndef lint
static char *RCSid = "$Header: depth.c,v 1.1 89/12/14 08:20:46 jay Exp $";
#endif /* not lint */

/*
**  depth.c
**
**  Set submarine depth
*/

#include "misc.h"
#include "var.h"
#include "xy.h"
#include "sect.h"
#include "ship.h"
#include "plane.h"
#include "nat.h"
#include "nsc.h"
#include "deity.h"
#include "file.h"

depth()
{
    extern	char *argp[];
    extern      int sub_hullair;
    struct	nstr_item ni;
    struct	shpstr sub;
    int		vec[I_MAX+1];
    int		itemvec[I_MAX+1];
    int		type;
    struct	sctstr sect;
    struct	mchrstr *mp;
    char	*p;
    int		i,dep,mcost,nships;
    
    if (!snxtitem(&ni, EF_SHIP, argp[1])) return RET_SYN;
    p = getstarg(argp[2],"What depth (surface, periscope, or deep)? ");

    dep = -1;
    if (p) switch (*p) {
    case 's': dep = 0; break;
    case 'p': dep = 1; break;
    case 'd': dep = 2; break;
    }
    if (dep < 0) return RET_SYN;

    for (nships=0; nxtitem(&ni, (char *)&sub);) {
	mp = &mchr[sub.shp_type];
	if (!owner || !issub(&sub)) continue;
	pr(fmt("%s #%d ",mp->m_name,ni.cur));
	getvec(VT_ITEM, vec, (char *)&sub, EF_SHIP);
	if (!vec[I_CIVIL] && !vec[I_MILIT]) {
	    pr("has no crew!\n");
	    continue;
	}
	getsect(sub.shp_x, sub.shp_y, &sect);
	if (dep>0) {
	    if ((sect.sct_type==SCT_HARBR)
#ifdef TRADECENTERS
		|| (sect.sct_type==SCT_TRADE)
#endif
		) {
		pr("can't submerge in a harbor!\n");
		continue;
	    }
	}
	if (dep == sub.shp_depth) {
	    pr("no change, running ");
	    switch (dep) {
	    case 0: pr("on surface"); break;
	    case 1: pr("at periscope depth"); break;
	    case 2: pr("deep"); break;
	    }
	}
	else {
	    switch (dep) {
	    case 0: 
		pr("surfacing"); 
		break;
	    case 1: 
		pr(fmt("%s to periscope depth",
		       (dep>sub.shp_depth) ? "submerging" : "rising"));
		break;
	    case 2: 
		pr("diving deep"); 
		break;
	    }
	    sub.shp_depth = dep;
	    if (dep==0 && sub.shp_air<sub_hullair) sub.shp_air = sub_hullair;
	    putship(sub.shp_uid, (char *)&sub);
	}
	pr(fmt(" in %s.\n",xyas(sub.shp_x,sub.shp_y,cnum)));
	nships++;
    }
    if (nships == 0) {
	pr(fmt("%s: No subs\n", (argp[1]) ? argp[1] : ""));
	return RET_FAIL;
    }
    pr(fmt("%d sub%s\n",nships,splur(nships)));
    return RET_OK;
}
