#ifndef lint
static char *RCSid = "$Header: navi.c,v 1.1 89/12/14 08:20:15 jay Exp $";
#endif

/*
 * navi.c
 *
 * navigate ships and such.
 *
 * from PSL Empire, 1985
 */

#include <ctype.h>
#include "misc.h"
#include "var.h"
#include "ship.h"
#include "sect.h"
#include "news.h"
#include "xy.h"
#include "nsc.h"
#include "nat.h"
#include "path.h"
#include "deity.h"
#include "file.h"
#include "shop.h"

double basemobcost();
extern double sub_slowdown;

static void ship_mess();
static int check_nav();
 /* return codes from check_nav */
#define CN_LANDLOCKED	(1)
#define CN_CONSTRUCTION	(2)
#define CN_ERROR	(-1)
#define CN_NAVIGABLE	(0)

#define sectis(x)	(sect.sct_type==(x))

navi()
{
    extern double techfact();
    extern char *argp[];
    struct sctstr sect;
    register n;
    register m;
    char   *cp,ip,*adj;
    int	max;
    int     dir;
    int     nships;
    coord     newx;
    coord     newy;
    coord     dx;
    coord     dy;
    int     stopping;
    int     viewing;
    int     snums[NS_LSIZE];
    int     mines;
    int     shells;
    int	mil;
    
    int	petcost;
    int	pets[NS_LSIZE];
    int radburner[NS_LSIZE];
    int	minpet;
    int nuclear;
    
    double  mobcost;
    double  mobils[NS_LSIZE];
    double  minmob;
    double  petburnodo;
    
    struct nstr_item nb;
    struct shpstr ships[NS_LSIZE];
    struct shpstr *shpq;
    struct shpstr *shpp;
    struct mchrstr *mcp;
    struct natstr *natp;
    int	vec[I_MAX+1];
    int	time_to_stop;
    
    if (!snxtitem(&nb, EF_SHIP, argp[1])) return RET_SYN;
    
    minmob = 9999.0;
    minpet = 9999;
    n = 0;
    natp = getnatp(cnum);
    
    while (nxtitem(&nb, (char *)&ships[n])) {
	
	if (!owner) continue;
	shpp = &ships[n];
	mcp = &mchr[shpp->shp_type];

	snums[n] = shpp->shp_uid;
	mobils[n] = (double) shpp->shp_mobil;
	if (!strncmp(mcp->m_name,"nuc",3) && !mcp->m_mpg)
	    radburner[n] = 
		vl_find(V_RAD,mcp->m_vtype,mcp->m_vamt,(int)mcp->m_nv);
	else
	    radburner[n] = 0;
	pets[n] = getvar(radburner[n] ? V_RAD : V_PETROL,
			 (char *)shpp, EF_SHIP);
	
	/*
	**  Check if this is a vehicle being ferried on a ship
	*/
	
	if (shpp->shp_aboard > -1) {
	    ship_mess("being transported",shpp);
	    continue;
	}
	
	/*
	**  Check if this is a balloon on the ground
	*/

	if (isballoon(shpp) && shpp->shp_depth==0) {
	    ship_mess("on the ground", shpp);
	    continue;
	}

	/*
	**  Check mobility 
	*/
	
	if (mobils[n] <= 0.0) {
	    ship_mess("out of mobility", shpp);
	    continue;
	} else if (mobils[n] < minmob)
	    minmob = mobils[n];
	
	getvec(VT_ITEM, vec, (char *)shpp, EF_SHIP);
	
	/*
	**  Check fuel
	*/
	
	if (radburner[n] || mcp->m_mpg) {
	    if (pets[n] <= 0) {
		ship_mess("out of fuel",shpp);
		continue;
	    } else if (!radburner[n] && (pets[n] < minpet)) 
		minpet = pets[n];
	}
	
	/*
	**  Check crew - uws don't count
	*/
	
	if (vec[I_MILIT] == 0 && vec[I_CIVIL] == 0) {
	    ship_mess("crewless", shpp);
	    continue;
	}
	
	if (!getsect(shpp->shp_x, shpp->shp_y, &sect))
	    return RET_SYN;
	
	/*
	 **  Check for other miscellanous conditions
	 */
	
	if (isship(shpp)) 
	    switch (check_nav(&sect)) {
	    case CN_CONSTRUCTION:
		ship_mess("caught in a construction zone", shpp);
		continue;
	    case CN_LANDLOCKED:
		ship_mess("landlocked", shpp);
		continue;
		/*NOTREACHED*/
	    case CN_NAVIGABLE:
		break;
	    case CN_ERROR:
	    default:
		ship_mess("subject to an empire error", shpp);
		continue;
		/*NOTREACHED*/
	    }
	
	n++;	    /* good ship - keep it */
    }
    
    if (n == 0) {
	pr("No vehicles\n");
	return RET_SYN;
    }
    nships = n;
    shpq = ships;
    stopping = 0;
    time_to_stop = 0;
    cp = argp[2];
    
    while (!stopping) {
	
	dx = dy = viewing = 0;
	
	if (cp == 0 || *cp == 0)
	    cp = getstring(fmt("<%.1f:%.1f: %s> ",
			       mobils[0],minmob,
			       xyas(shpq->shp_x, shpq->shp_y, cnum)));
	
	if (cp == 0 || *cp == 0)
	    cp = &dirch[DIR_STOP];
	
	if (*cp == 'p') {
	    if (mchr[shpq->shp_type].m_mpg)
		pr(fmt("%d petrol remaining\n",pets[0]));
	    else
		pr("not burning petrol\n");
	    cp = 0;
	    continue;
	}
	
	if (*cp == 'r' || *cp == 'l' || *cp == 's') {
	    char snumbuf[80];
	    ip = *cp++;
	    while (*cp && *cp<=' ') cp++;
	    if (*cp && *cp!='.') strcpy(snumbuf,cp);
	    else sprintf(snumbuf,"%d",snums[0]);
	    argp[1] = *cp ? snumbuf : 0;
	    for (n = 0; n < nships; n++)
		if (snums[n] != -1) putship(snums[n], &ships[n]);
	    switch (ip) {
	    case 'r': rada(); break;
	    case 'l': look(); break;
	    case 's': sona(); break;
	    }
	    NAT_DELTA(nat_btu, cnum, -1);
	    cp = 0;
	    continue;
	}
	
	dir = chkdir(*cp++, DIR_STOP, DIR_VIEW);
	if (dir == -1) {
	    pr(fmt("\"%c\" is not legal...", cp[-1]));
	    direrr("`%c' to stop",
"\n`%c' to view\n`r' to radar\n`l' to look\n`s' to sonar\n`p' to show petrol remaining\n",0);
	    cp = "";
	    continue;
	}
	
	if (dir == DIR_VIEW)
	    viewing++;
	else if (dir == DIR_STOP)
	    stopping++;
	else {
	    dx = diroff[dir][0];
	    dy = diroff[dir][1];
	}
	
	minmob = 9999.0;
	for (n = 0; n < nships; n++) {
	    if (snums[n] == -1)
		continue;
	    shpp = &ships[n];
	    nuclear = (int)radburner[n];
	    mcp = &mchr[shpp->shp_type];
	    newx = xnorm(shpp->shp_x + dx);
	    newy = ynorm(shpp->shp_y + dy);
	    getsect(newx, newy, &sect);
	    
	    petcost = 0;
	    if (viewing || stopping || god)
		mobcost = 0.0;
	    else {

		mobcost = basemobcost(shpp,pets[n],nuclear);

		petcost = (int)dchr[sect.sct_type].d_mcst;
		if (petcost == 0) petcost = 1;
		if ((mcp->m_flags & M_ATV) && (petcost > 5)) petcost = 5;
		mobcost *= petcost;

		petcost = 0;
		if (!nuclear && mcp->m_mpg) {
		    if (shpp->shp_odom < 0) shpp->shp_odom = 0;
		    petburnodo  = (double)(mchr[shpp->shp_type].m_mpg)/10.0;
		    petburnodo *= (double)(shpp->shp_tech+200)/200.0;
		    petburnodo *= (double)(shpp->shp_effic)/100.0;
		    if (petburnodo < 1.0) petburnodo = 1.0;
		    if (petburnodo > 127.0) petburnodo = 127.0;
		    petcost = ((shpp->shp_odom+1) >= (int)petburnodo) ? 1 : 0;
		}
	    }
	    
	    adj = "";

	    if (sectis(SCT_TRADE) && !owner && sect.sct_own) {
		int isopen;
		tradecenter shop;
		lockshop();
		if (!getshop(sect.sct_x,sect.sct_y,&shop)) isopen=0;
		else isopen=shopstatus(&shop,cnum,2);
		unlockshop();
		if (!isopen) adj = "enter";
	    }

	    if (isship(shpp)) {
		if (check_nav(&sect) != CN_NAVIGABLE ||
		    ((!sectis(SCT_TRADE) && !sectis(SCT_BSPAN) && 
		      sect.sct_own && !owner &&
		      getrel(getnatp(sect.sct_own),cnum) != ALLIED))) {
		    adj = "go to";
		} else {
		    if (shpp->shp_depth>0 && 
			(sectis(SCT_TRADE) || sectis(SCT_HARBR)))
			adj = "go submerged into";
		}
	    } else { 
		dpr(fmt("validterrain('%c',\"%s\")?  ",
			dchr[sect.sct_type].d_mnem,mcp->m_terrain));
		if(!validterrain(dchr[sect.sct_type].d_mnem,mcp->m_terrain)) {
		    switch (mcp->m_class) {
		    case CLASS_TANK: adj = "drive to"; break;
		    case CLASS_BALLOON: adj = "fly to"; break;
		    default: adj = "travel to";
		    }
		    dpr(fmt("No!  Can't %s there.\n",adj));
		} else dpr("Yes.\n");
	    }

	    if (*adj) {
		pr(fmt("%s can't %s %s\n",
		       shipas(shpp,0),adj,xyas(newx, newy, cnum)));
		cp = 0;
		if (mobils[n] < minmob) minmob = mobils[n];
		if (!nuclear && mcp->m_mpg)
		    if (pets[n] < minpet) minpet = pets[n];
		continue;
	    }
	    
	    if (mobcost > 0.0) {
		if (cannotleave(shpp,&mobcost,&petcost,2,1)) {
		    cp = 0;
		    mobils[n] -= mobcost;
		    pets[n] -= petcost;
		    pr(fmt("Failed attempt cost %d pet %.1f mob\n",
			   petcost,mobcost));
		    if (mobils[n] < minmob) minmob = mobils[n];
		    if (!nuclear && mcp->m_mpg)
			if (pets[n] < minpet) minpet = pets[n];
		    continue;
		}
	    }
	    
	    if (viewing) {
		if (istrain(shpp)) {
		    /* special vehicle viewing stuff here */
		}
		if (istank(shpp)) {
		    /* special vehicle viewing stuff here */
		} 
		if (isballoon(shpp)) {
		    /* special airship viewing stuff here */
		}
		if (mcp->m_flags & M_FOOD)
		    pr(fmt("[fert:%d] ", sect.sct_fertil));
		if (mcp->m_flags & M_OIL)
		    pr(fmt("[oil:%d] ", sect.sct_oil));
		pr(fmt("%s @ %s %d%% %s %s\n", shipas(shpp,0),
		       xyas(newx, newy, cnum),
		       sect.sct_effic,
		       cname(sect.sct_own),
		       dchr[sect.sct_type].d_name));
	    }
	    if (n == 0) {
		radmapnopr(newx, newy, (int)shpp->shp_effic, 
			   (int)techfact(shpp->shp_tech,
					 (double) mchr[shpp->shp_type].m_vrnge),
			   (double)((mchr[shpp->shp_type].m_flags & M_SONAR)
				    ? techfact(shpp->shp_tech, 1.0) : 0.0));
	    }
	    shpp->shp_x = newx;
	    shpp->shp_y = newy;
	    mobils[n] -= mobcost;
	    pets[n] -= petcost;
	    
	    if (!nuclear && mcp->m_mpg)
		shpp->shp_odom = petcost ? 0 : shpp->shp_odom+1;
	    
	    if ((mobils[n] <= 0.0) || stopping ||
		(!nuclear && mcp->m_mpg && (pets[n] <= 0))) {
		if (!nuclear && mcp->m_mpg && (pets[n] <= 0))
		    pr(fmt("%s out of fuel at %s\n", shipas(shpp,0),
			   xyas(shpp->shp_x, shpp->shp_y, cnum)));
		else
		    pr(fmt("%s stopped at %s\n", shipas(shpp,0),
			   xyas(shpp->shp_x, shpp->shp_y, cnum)));
		
		shpp->shp_mobil = (int) mobils[n];
		if (!nuclear && mcp->m_mpg) {
		    if (pets[n] < 0) pets[n] = 0;
		    putvar(V_PETROL,pets[n],(char *)shpp, EF_SHIP);
		}
		putship(snums[n], shpp);
		snums[n] = -1;
		time_to_stop = 1;
		cp = &dirch[DIR_STOP];
	    }
	    
	    if (!nuclear && mcp->m_mpg)
		if (pets[n] < minpet) minpet = pets[n];
	    if (mobils[n] < minmob)
		minmob = mobils[n];
	    if (viewing || stopping || !isship(shpp) || shpp->shp_depth>1)
		continue;
	    
	    mines = getvar(V_MINE, (char *)&sect, EF_SECTOR);
	    owner = (sect.sct_own == shpp->shp_own);

	    if ((mcp->m_flags & M_SWEEP) && mines > 0 && !owner) {
		max = vl_find(V_SHELL, mcp->m_vtype,
			      mcp->m_vamt, (int) mcp->m_nv);
		shells = getvar(V_SHELL, (char *)shpp, EF_SHIP);
		for (m=0; mines > 0 && m < 5; m++) {
		    if (chance(0.66)) {
			pr("Sweep...\n");
			mines--;
			shells = min(max, shells + 1);
			setbigmap(newx,newy,0x81);
		    }
		}
		putvar(V_MINE, mines, (char *)&sect, EF_SECTOR);
		putvar(V_SHELL, shells, (char *)shpp, EF_SHIP);
		putsect(&sect);
	    }
	    if (mines > 0 && !owner 
		&& chance(((mcp->m_flags & M_SWEEP) ? 0.03 : 0.05) * mines)) {
		pr(fmt("\007Kawhomp! Mine detected by %s in %s!\n",
		       shipas(shpp,0), xyas(newx, newy, cnum)));
		nreport(cnum, N_HIT_MINE, 0, 1);
		if (mcp->m_glim)
		    m = 15 + 1350 / mcp->m_armor;
		else
		    m = 2100 / (mcp->m_vrnge*mcp->m_visib);
		m += random() % 21;
		shipdamage(shpp, m);
		mines--;
		setbigmap(newx,newy,0x81);
		putvar(V_MINE, mines, (char *)&sect, EF_SECTOR);
		putsect(&sect);
		cp = 0;
		if (shpp->shp_effic < 20) {
		    time_to_stop = 1;
		    snums[n] = -1;
		}
		putship(shpp->shp_uid, (char *)shpp);
		pr(fmt("%d%% damage sustained\n", m));
	    }
	}
	if (time_to_stop)
	    stopping = 1;
    }
    for (n = 0; n < nships; n++) {
	if (snums[n] == -1)
	    continue;
	shpp = &ships[n];
	if (shpp->shp_own == 0)
	    continue;
	mcp = &mchr[shpp->shp_type];
	pr(fmt("%s stopped at %s\n", shipas(shpp,0),
	       xyas(shpp->shp_x, shpp->shp_y, cnum)));
	if (mobils[n] < 0)
	    mobils[n] = 0;
	if (!nuclear && mcp->m_mpg) {
	    if (pets[n] < 0) pets[n] = 0;
	    putvar(V_PETROL,pets[n],(char *)shpp, EF_SHIP);
	}
	shpp->shp_mobil = mobils[n];
	putship(snums[n], shpp);
    }
    writebigmap();
    return RET_OK;
}

static void ship_mess(str, shp)
struct shpstr *shp;
char *str;
{
    extern struct mchrstr mchr[];
    pr(fmt("%s is %s & stays in %s\n",
	   shipas(shp,0), str, xyas(shp->shp_x, shp->shp_y, shp->shp_own)));
}

static int check_nav(sect)
struct sctstr *sect;
{
    extern struct dchrstr dchr[];
    switch (dchr[sect->sct_type].d_flg & 03) {
    case NAV_60: if (sect->sct_effic < 60) return CN_CONSTRUCTION;
    case NAV_02: if (sect->sct_effic < 2) return CN_CONSTRUCTION;
    case NAVOK:  break;
    default:     return CN_LANDLOCKED;
    }
    return CN_NAVIGABLE;
}

double basemobcost(sp,rads,nuclear)
struct shpstr *sp;
int rads, nuclear;
{
    double mobcost;
    mobcost = (nuclear>0) ? ((double)rads/(double)nuclear) : 1.0;
    if (mobcost > 1.0) mobcost = 1.0;
    mobcost *= (sp->shp_effic * 0.01 * mchr[sp->shp_type].m_speed);
    mobcost = 480.0 /
	(mobcost + techfact(sp->shp_tech, mobcost));
    if ((mchr[sp->shp_type].m_flags & M_SUB) && (sp->shp_depth>0)) {
	mobcost = mobcost * sub_slowdown;
    }
    return (mobcost);
}
