#ifndef lint
static char *RCSid = "$Header: shi.c,v 1.1 89/12/14 08:20:51 jay Exp $";
#endif /* not lint */

/*
 * shi.c
 *
 * from PSL Empire, 1985
 */

#include "misc.h"
#include "var.h"
#include "xy.h"
#include "sect.h"
#include "ship.h"
#include "nat.h"
#include "nsc.h"
#include "deity.h"
#include "file.h"

vehi()
{ 
    int i;
    extern char *argp[];
    struct nstr_item ni;
    if (!snxtitem(&ni, EF_SHIP, argp[1])) return RET_SYN;
    for (i=0; i<NUM_CLASSES; i++) shi(i);
    return RET_OK;
}

tank() { shi(CLASS_TANK); }
ball() { shi(CLASS_BALLOON); }
trai() { shi(CLASS_TRAIN); }
ship() { shi(CLASS_SHIP); }

shi(vc)
int vc;
{
    extern char *argp[];
    struct nstr_item ni;
    struct shpstr ship;
    int	nships;
    
    if (vc==CLASS_BALLOON && argp[2] && *argp[2]!='n') 
	return setaltitude();

    if (!snxtitem(&ni, EF_SHIP, argp[1])) return RET_SYN;
    for (nships=0; nxtitem(&ni, (char *)&ship);) {
	if (!owner || ship.shp_own == 0) continue;
	if (ship.shp_type<0 || ship.shp_type>shp_maxno) {
	    pr(fmt("bad ship type %d (#%d)\n", ship.shp_type, ni.cur));
	    continue;
	}
	if (vehicleclass(&ship) != vc) continue;
	if (argp[2] && *argp[2]=='n') vcshowname(&ship,(nships==0),0,vc);
	else if (argp[2] && *argp[2]=='c') vcshowcargo(&ship,(nships==0),0,vc);
	else vcshowvehicle(&ship,(nships==0),0,vc);
	nships++;
    }
    return summarize(argp[1],nships,class[vc].name);
}

showvehicle(ship,header,plusorminus)
struct shpstr *ship;
int header,plusorminus;
{
    return vcshowvehicle(ship,header,plusorminus,mchr[ship->shp_type].m_class);
}

vcshowvehicle(ship,header,plusorminus,vc)
struct shpstr *ship;
int header,plusorminus,vc;
{
    int	vec[I_MAX+1];
    if (vc != -1)
	if (vc != mchr[ship->shp_type].m_class) return 0;
    if (header) {
	prest(plusorminus);
	if (god || plusorminus) pr("own ");
	prvcheader(vc,"   x,y    f/c  eff");
	switch(vc) {
	case CLASS_TANK:    pr(" mil gun  sh food  shp pet mob tech\n"); break;
	case CLASS_BALLOON: pr("  alt civ  mil food mob tech  gas\n"); break;
	default:            pr(" civ  mil   uw food pln mob tech tnk\n"); break;
	}
    }
    getvec(VT_ITEM, vec, (char *)ship, EF_SHIP);
    if (god || plusorminus) pr(fmt("%3d ", ship->shp_own));
    pr(fmt("%4d ", ship->shp_uid));
    pr(fmt("%-15.15s ", mchr[ship->shp_type].m_name));
    pr(fmt("%s", xyfmt("%4d,%-4d", ship->shp_x,ship->shp_y, cnum)));
    pr(fmt(" %1c %1c", ship->shp_fleet,ship->shp_convoy));
    pr(fmt("%4d%%", limestimate(ship->shp_effic,plusorminus,0,100)));
    switch (vc) {
    case CLASS_TANK:
	pr(fmt("%4d", estimate(vec[I_MILIT],plusorminus)));
	pr(fmt("%4d", estimate(vec[I_GUN],plusorminus)));
	pr(fmt("%4d", estimate(vec[I_SHELL],plusorminus)));
	pr(fmt("%5d", estimate(vec[I_FOOD],plusorminus)));
	if (ship->shp_aboard>=0) pr(fmt("%5d", ship->shp_aboard));
	else pr("     ");
	pr(fmt("%4d", estimate(vec[I_PETROL],plusorminus)));
	pr(fmt("%4d", estimate(ship->shp_mobil,plusorminus)));
	pr(fmt("%5d\n", estimate(ship->shp_tech,plusorminus)));
	break;
    case CLASS_BALLOON:
        switch (ship->shp_depth) {
	case 0: pr(" land"); break;
	case 1: pr("  low"); break;
	case 2: pr(" high"); break;
	default:pr(" ????");
	}
	pr(fmt("%4d", estimate(vec[I_CIVIL],plusorminus)));
	pr(fmt("%5d", estimate(vec[I_MILIT],plusorminus)));
	pr(fmt("%5d", estimate(vec[I_FOOD],plusorminus)));
	pr(fmt("%4d", estimate(ship->shp_mobil,plusorminus)));
	pr(fmt("%5d", estimate(ship->shp_tech,plusorminus)));
	pr(fmt("%5d\n", estimate(ship->shp_air,plusorminus)));
	break;
    default:
	pr(fmt("%4d", estimate(vec[I_CIVIL],plusorminus)));
	pr(fmt("%5d", estimate(vec[I_MILIT],plusorminus)));
	pr(fmt("%5d", estimate(vec[I_UW],plusorminus)));
	pr(fmt("%5d", estimate(vec[I_FOOD],plusorminus)));
	pr(fmt("%4d", estimate(ship->shp_nplane,0)));
	pr(fmt("%4d", estimate(ship->shp_mobil,plusorminus)));
	pr(fmt("%5d", estimate(ship->shp_tech,plusorminus)));
	pr(fmt("%4d\n", estimate(ship->shp_ntank,0)));
    }
    return 1;
}    

showname(ship,header,plusorminus)
struct shpstr *ship;
int header,plusorminus;
{
    return vcshowname(ship,header,plusorminus,mchr[ship->shp_type].m_class);
}

vcshowname(ship,header,plusorminus,vc)
struct shpstr *ship;
int header,plusorminus,vc;
{
    int	vec[I_MAX+1];
    struct sctstr sect;
    if (vc != -1)
	if (vc != mchr[ship->shp_type].m_class) return 0;
    if (!getsect(ship->shp_x,ship->shp_y,&sect)) return;
    if (header) {
	prest(plusorminus);
	if (god || plusorminus) pr("own ");
	prvcheader(vc,"   name         x,y   sct  eff civ mil pet mob tech\n");
    }
    getvec(VT_ITEM, vec, (char *)ship, EF_SHIP);
    if (god || plusorminus) pr(fmt("%3d ", ship->shp_own));
    pr(fmt("%4d ", ship->shp_uid));
    pr(fmt("%-16.16s ", mchr[ship->shp_type].m_name));
    pr(fmt("%-11.11s ", ship->shp_name));
    pr(fmt("%s ", xyfmt("%4d,%-4d", ship->shp_x,ship->shp_y, cnum)));
    pr(fmt("%c ", dchr[sect.sct_type].d_mnem));
    pr(fmt("%4d%%", limestimate(ship->shp_effic,plusorminus,0,100)));
    pr(fmt("%4d", estimate(vec[I_CIVIL],plusorminus)));
    pr(fmt("%4d", estimate(vec[I_MILIT],plusorminus)));
    pr(fmt("%4d", estimate(vec[I_PETROL],plusorminus)));
    pr(fmt("%4d\n", estimate(ship->shp_mobil,plusorminus)));
    return 1;
}    

setaltitude()
{
    extern	char *argp[];
    struct	nstr_item ni;
    struct	shpstr bal;
    int		vec[I_MAX+1];
    int		itemvec[I_MAX+1];
    int		type;
    struct	sctstr sect;
    struct	mchrstr *mp;
    char	*p;
    int		i,delta,alt,mcost,nbals;
    
    if (!snxtitem(&ni, EF_SHIP, argp[1])) return RET_SYN;
    p = getstarg(argp[2],"Climb or descend? ");

    delta = 0;
    if (p) switch (*p) {
    case 'c': delta = 1; break;
    case 'd': delta = -1; break;
    }
    if (!delta) return RET_SYN;

    for (nbals=0; nxtitem(&ni, (char *)&bal);) {
	if (bal.shp_type < 0 || bal.shp_type > shp_maxno) {
	    pr(fmt("bad balloon type %d (#%d)\n",bal.shp_type, ni.cur));
	    continue;
	}
	if (!owner || !bal.shp_own || !isballoon(&bal)) continue;
	mp = &mchr[bal.shp_type];
	pr(fmt("%s ",shipas(&bal,0)));
	getvec(VT_ITEM, vec, (char *)&bal, EF_SHIP);
	alt = max(min(bal.shp_depth+delta,2),0);
	if (!vec[I_CIVIL] && !vec[I_MILIT]) {
	    if (!(bal.shp_depth==0 && alt>bal.shp_depth)) {
		pr("has no crew!\n");
		continue;
	    } else {
		pr("released unmanned, ");
	    }
	}
	if (bal.shp_mobil <= 0) {
	    pr("out of mobility.\n");
	    continue;
	}

	if (alt > bal.shp_depth) {
	    if ((alt==1 && (bal.shp_air < mchr[bal.shp_type].m_maxair/2)) ||
		(alt==2 && (bal.shp_air < mchr[bal.shp_type].m_maxair*3/4))) {
		pr(fmt("has only %d gas, needs %d to reach %s altitude\n",
		       bal.shp_air,
		       (alt==1) ? mchr[bal.shp_type].m_maxair/2
		       : mchr[bal.shp_type].m_maxair*3/4,
		       (alt==1) ? "low" : "high"));
		continue;
	    }
	}

	getsect(bal.shp_x, bal.shp_y, &sect);
	if (alt==0) {
	    if (!stypeinlist(class[CLASS_BALLOON].loadplace,sect.sct_type)) {
		pr(fmt("can't land in %s.\n(Sector must be a %s.)\n",
		       xyas(bal.shp_x, bal.shp_y, cnum),
		       fmslist(class[CLASS_BALLOON].loadplace)));
		continue;
	    }
	}
	if (alt == bal.shp_depth) {
	    pr("no change, remaining ");
	    switch (alt) {
	    case 0: pr("on the ground"); break;
	    case 1: pr("at low altitude"); break;
	    case 2: pr("at high altitude"); break;
	    }
	}
	else {
	    switch (alt) {
	    case 0: pr("landing"); break;
	    case 2: pr("climbing to high altitude"); break;
	    case 1: pr(fmt("%s to low altitude",
			   (alt>bal.shp_depth) ? "climbing" : "descending"));
		break;
	    }
	    bal.shp_depth = alt;
	    bal.shp_mobil--;
	    putship(bal.shp_uid, (char *)&bal);
	}
	pr(fmt(" in %s.\n",xyas(bal.shp_x,bal.shp_y,cnum)));
	nbals++;
    }
    return summarize(argp[1],nbals,"balloon");
}
