#ifndef lint
static char *RCSid = "$Header: strafe.c,v 1.0 91/11/11 08:19:16 bill Exp $";
#endif

/*
** strafe.c
**
** Fly strafing missions.
*/

#include <ctype.h>
#include "misc.h"
#include "var.h"
#include "class.h"
#include "sect.h"
#include "ship.h"
#include "item.h"
#include "plane.h"
#include "nuke.h"
#include "xy.h"
#include "nsc.h"
#include "news.h"
#include "file.h"
#include "nat.h"
#include "loc.h"
#include "path.h"

extern double effstrafe_mult;
extern double effstrafe_subt;
extern int pinstrafe_base;
extern int pinstrafe_range;
extern int aborted;

static char *pqtys(n,item)
int n,item;
{
    if (n>500) return "mass ";
    if (n>200) return "lots of ";
    if (n>50)  return "many ";
    if (n>10)  return "some ";
    return "a few ";
}

int ratatat(acc,armor)
int acc, armor;
{
    int i;
    pr("!! rat-a-tat-a-tat-a-tat ");
    for (i=roll(7)+2; i; i--) pr("!!");
    pr("\n");
    if (roll(100) > acc)
	return ((roll(4)+1) * 127) / armor;
    return 0;
}

int showpoplevels(target)
struct sctstr *target;
{
    int i, vec[I_MAX+1];
    getvec(VT_ITEM, vec, target, EF_SECTOR);
    i = max(vec[I_MILIT] - target->sct_harden, 0);
    if (i) pr(fmt("  %smil\n",pqtys(i)));
    if (vec[I_CIVIL]) pr(fmt("  %scivs\n",pqtys(vec[I_CIVIL])));
    if (vec[I_UW])  pr(fmt("  %suws\n",pqtys(vec[I_UW])));
    return vec[I_CIVIL]+vec[I_MILIT]+vec[I_UW];
}    

strafe()
{
    extern char *argp[];
    char *p, mission,flightpath[256];
    int	mission_flags, ap_to_target;
    coord x, y, tx, ty, ax, ay;
    struct ichrstr *ip;
    struct nstr_item ni_strafe;
    struct sctstr target, ap_sect;
    struct qelem strafe_list, esc_list;
    
    if (!snxtitem(&ni_strafe, EF_PLANE, argp[1]))	return RET_SYN;
    esc_list.q_forw = &esc_list; 			/* no escorts */
    if (!getassemblypoint(argp[1],argp[2],&x,&y))	return RET_SYN;
    if (!getsect(x, y, &ap_sect))			return RET_SYN;
    
#ifndef ASSEMBLEANYWHERE
    if (ap_sect.sct_own && ap_sect.sct_own != cnum) {
	pr("Assembly point not owned by you!\n");
	return RET_SYN;
    }
#endif

    tx = ax = x;
    ty = ay = y;
    p = getpath(argp[3], ax, ay, 0, 0, 0);
    if (!p || !*p) return RET_SYN;
    (void)strcpy(flightpath, p);

    (void) pathtoxy(flightpath, &tx, &ty, fcost);
    pr(fmt("target sector is %s\n", xyas(tx, ty, cnum)));
    getsect(tx, ty, &target);
    if (target.sct_type == SCT_SANCT) {
	pr("You can't strafe a sanctuary!\n");
	return RET_SYN;
    }
    ap_to_target = strlen(flightpath);
    pr(fmt("range to target is %d\n", ap_to_target));

    /* select planes within range */
    pln_sel(&ni_strafe, &strafe_list, &ap_sect, ap_to_target,
	    2, 0, P_M|P_O|P_B|P_C, (char *)0);

    /* arm and equip the planes */
    ip = 0;
    mission_flags = 0x7fff0000 | P_X;
    mission_flags = pln_arm(&strafe_list, mission, ip, 0, mission_flags);
    if (QEMPTY(&strafe_list)) {
	pr("No planes could be equipped for the mission.\n");
	return RET_FAIL;
    }
    mission_flags = pln_arm(&esc_list, mission, ip, P_F, mission_flags);
    ac_encounter(&strafe_list, &esc_list, ax, ay, flightpath, mission_flags);
    if (QEMPTY(&strafe_list)) {
	pr(fmt("No planes got through fighter defenses\n"));
    } else {
	getsect(tx, ty, &target);
	pln_strafe(&strafe_list, &target, argp[4]);
	putsect(&target);
    }
    pln_put(&strafe_list);
    return RET_OK;
}

static pln_strafe(list, target, targlist)
struct qelem *list;
struct sctstr *target;
char *targlist;
{
    extern	char *effadv();
    extern	int aborted;
    struct	dchrstr *dcp;
    int	nplanes, ntanks, nballoons, ntrains, nships;
    int	type, passes, done, shot, bad, i;
    char *p;
    int	vec[I_MAX+1];
    struct qelem *qp;
    struct plist *plp;

    /* Set the number of strafing passes each plane can make */
    for (qp = list->q_forw; qp!=list && !aborted; qp = qp->q_forw) {
	plp = (struct plist *) qp;
	plp->bombs = plp->pcp->pl_load;
    }

    for (shot=1, done=passes=0; !done;) {

	/* See if anybody's got any ammo left */
	i = 0;
	for (qp = list->q_forw; qp!=list && !aborted; qp = qp->q_forw) {
	    plp = (struct plist *) qp;
	    i += plp->bombs;
	}
	if (!i) break;

	if (shot) {
	    type = target->sct_type;
	    dcp = &dchr[type];
	    shipsatxy(target->sct_x,target->sct_y,0,M_SUB);
	    tanksatxy(target->sct_x,target->sct_y,0,0);
	    trainsatxy(target->sct_x,target->sct_y,0,0);
	    balloonsatxy(target->sct_x,target->sct_y,0,0);
	    planesatxy(target->sct_x,target->sct_y,0,0);
	    getvec(VT_ITEM, vec, (char *)target, EF_SECTOR);
	    if (passes) 
		pr(fmt("\nComing around for pass #%d...\n",passes+1));
	    else {
		pr(fmt("Target sector is a %s constructed %s:\n", 
			effadv((int)target->sct_effic), dcp->d_name));
		pr("\nComing in for first pass...\n");
	    }
	}
	
	for (bad=0; bad<2; bad++) {
	    p = getstring(
  "Strafe what (ship, tank, train, balloon, plane, populous, quit)? ");
	    if (p && *p) break;
	}
	if (bad>=2) p = "q";
	
	shot = 0;
	switch (*p++) {
	case 's':
	    shot = veh_strafe(list,target,CLASS_SHIP);
	    break;
	case 't':
	    shot = veh_strafe(list,target,*p=='r'?CLASS_TRAIN:CLASS_TANK);
	    break;
	case 'b':
	    shot = veh_strafe(list,target,CLASS_BALLOON);
	    break;
	case 'p':
	    if (*p=='o' || *p=='e') shot = people_strafe(list, target);
	    else shot = plane_strafe(list, target);
	    break;
	case 'q':
	    done = 1;
	    break;
	default:
	    pr("bad target type\n");
	}
	if (shot) passes++;
    }
    pr("\nAircraft returning to base\n");
    return;
}

static int veh_strafe(list, target, vc)
struct	qelem *list;
struct	sctstr *target;
int vc;
{
    extern int aborted;
    struct plist *plp;
    struct mchrstr *mcp;
    struct qelem *qp;
    struct shpstr ship;
    char *q, buf[80];
    int	acc,vis,dam,i,n,shipno,shots;
    
    if (!vatxy(target->sct_x,target->sct_y,0,M_SUB,vcmask(vc,-1,-1,-1),0)) {
	pr(fmt("No discernable %s targets\n",class[vc].name));
	return 0;
    }

    shots = 0;
    for (qp = list->q_forw; qp != list && !aborted; qp = qp->q_forw) {
	plp = (struct plist *) qp;
	if (plp->bombs <= 0) continue;
	sprintf(buf, "%s (#%d); target %s id (`?' to list, `d' to defer)? ",
		plp->pcp->pl_name, plp->plane.pln_uid,
		class[vc].name);

	for (shipno = -1; shipno < 0 && !aborted;) {
	    if ((q = getstring(buf)) == 0 || *q == 0) continue;
	    if (*q == '?') {
		vatxy(target->sct_x,target->sct_y,0,M_SUB,
		      vcmask(vc,-1,-1,-1),0);
		continue;
	    }
	    if (*q=='d') goto next; /* defer */
	    if (!isdigit(*q)) continue;
	    n = atoi(q);
	    if (n < 0) continue;
	    if (getship(n, &ship)
		&& (mchr[ship.shp_type].m_class==vc)
		&& (ship.shp_x==target->sct_x)
		&& (ship.shp_y==target->sct_y))
		shipno = n;
	}

	if (shipno < 0) continue;
	mcp = &mchr[ship.shp_type];
	vis = mcp->m_visib;
	acc = plp->pcp->pl_acc - vis;
	dam = ratatat(acc,mcp->m_armor);
	if (dam > 100) dam = 100;
	if (--plp->bombs == 0)
	    pr(fmt("%s (#%d) out of ammo\n",
		   plp->pcp->pl_name, plp->plane.pln_uid));

	switch (vc) {
	case CLASS_TANK:    i = N_TNK_STRAFE; break;
	case CLASS_BALLOON: i = N_BAL_STRAFE; break;
	case CLASS_TRAIN:   i = N_TRN_STRAFE; break;
	default:	    i = N_SHP_STRAFE;
	}
	nreport(cnum,i, ship.shp_own, 1);

	pr(fmt("estimated damage: %d%%\n", limestimate(dam,20,0,100)));
	wu(0, ship.shp_own, 
	   fmt("%s strafing raid did %d%% damage to %s",
	       cname(cnum), dam, shipasc(&ship,LS,ship.shp_own)));
	pr("\n");
	shipdamage(&ship, dam);
	putship(n, &ship);
	shots++;
    next:
	;
    }
    return shots;
}

static int plane_strafe(list, target)
struct	qelem *list;
struct	sctstr *target;
{
    int	acc, dam, i, n, shots;
    char *q;
    natid own;
    char buf[80];
    struct plnstr plane;
    struct qelem *qp;
    int	planeno;
    struct plist *plp;
    
    if (!planesatxy(target->sct_x, target->sct_y, 0, 0)) {
	pr("No discernable aircraft targets\n");
	return 0;
    }

    shots = 0;
    for (qp = list->q_forw; qp != list; qp = qp->q_forw) {
	plp = (struct plist *) qp;
	if (plp->bombs <= 0) continue;
	sprintf(buf, "%s (#%d); target plane id (`?' to list, `d' to defer)? ",
		plp->pcp->pl_name, plp->plane.pln_uid);
	planeno = -1;
	while (planeno < 0 && !aborted) {
	    if (!(q = getstring(buf)) || !*q) continue;
	    if (*q == '?') {
		planesatxy(target->sct_x, target->sct_y, 0, 0);
		continue;
	    }
	    if (*q == 'd') goto next; /* defer */
	    n = atoi(q);
	    if (n < 0) continue;
	    if (getplane(n, &plane) &&
		plane.pln_x == target->sct_x &&
		plane.pln_y == target->sct_y &&
		(plane.pln_flags & PLN_LAUNCHED) == 0)
		planeno = n;
	    else
		pr(fmt("Plane #%d not spotted\n", n));
	}
	if (planeno < 0) continue;
	acc = plp->pcp->pl_acc;
	dam = ratatat(acc,plchr[plane.pln_type].pl_def);
	if (dam > 100) dam = 100;
	if (--plp->bombs == 0)
	    pr(fmt("%s (#%d) out of ammo\n",
		   plp->pcp->pl_name, plp->plane.pln_uid));

	own = plane.pln_own;
	if (dam > plane.pln_effic) {
	    plane.pln_effic = 0;
	    plane.pln_own = 0;
	} else
	    plane.pln_effic -= dam;

	plane.pln_mobil = (dam * plane.pln_mobil / 100.0);
	pr(fmt("estimated damage: %d%%\n", limestimate(dam,20,0,100)));
	wu(0, own,
	   fmt("%s strafing raid did %d%% damage to %s #%d in %s",
	       cname(cnum), dam, plchr[plane.pln_type].pl_name, n,
	       xyas(target->sct_x, target->sct_y, own)));
	nreport(cnum, N_PLN_STRAFE, plane.pln_own, 1);
	putplane(n, &plane);
	shots++;
    next:
	;
    }
}

static int people_strafe(list, target)
struct	qelem *list;
struct	sctstr *target;
{
    register struct plist *plp;
    float eff, damage;
    char buf1[20],buf[80],*q;
    int	i,j,k,n,shots;
    struct qelem *qp;
    int vec[I_MAX+1];
    int civs, mil, uws, item;
    int dcivs, dmil, duws;
    
    if (!showpoplevels(target)) {
	pr("No discernable human targets\n");
	return 0;
    };

    shots = 0;
    for (qp = list->q_forw; qp != list; qp = qp->q_forw) {
	plp = (struct plist *) qp;
	if (plp->bombs <= 0) continue;

	getvec(VT_ITEM, vec, target, EF_SECTOR);
	civs = vec[I_CIVIL];
	mil  = vec[I_MILIT];
	uws  = vec[I_UW];
	sprintf(buf, "%s (#%d); strafe who (`?' to list, `d' to defer)? ",
		plp->pcp->pl_name, plp->plane.pln_uid);

	item = 0;
	while (!item && !aborted) {
	    if (!(q = getstring(buf)) || !*q) continue;
	    if (*q == '?') {
		showpoplevels(target);
		continue;
	    }
	    switch (*q) {
	    case 'd': goto next; /* defer */
	    case 'm': item = I_MILIT; break;
	    case 'c': item = I_CIVIL; break;
	    case 'u': item = I_UW; break;
	    }
	}
	if (!item) continue;

	ratatat(0,1);
	if (--plp->bombs == 0)
	    pr(fmt("%s (#%d) out of ammo\n",
		   plp->pcp->pl_name, plp->plane.pln_uid));

	/* compute new populations */

	i = chance(0.1) ? (roll(20)+4)  : (roll(5)-1);  /* mil slop */
	j = chance(0.1) ? (roll(20)+4)  : (roll(5)-1);  /* civ slop */
	k = chance(0.1) ? (roll(20)+4)  : (roll(5)-1);  /* uws slop */
	n = chance(0.1) ? (roll(50)+10) : (roll(20)-1); /* primary target */
	
	vec[I_MILIT] = max(mil -((item==I_MILIT) ? n : i), target->sct_harden);
	vec[I_CIVIL] = max(civs-((item==I_CIVIL) ? n : j), 0);
	vec[I_UW] =    max(uws -((item==I_UW   ) ? n : k), 0);
	putvec(VT_ITEM, vec, target, EF_SECTOR);

	/* compute losses */
	mil  -= vec[I_MILIT];
	uws  -= vec[I_UW];
	civs -= vec[I_CIVIL];

	pr(fmt("estimated casualties: %d\n", estimate(mil+uws+civs,20)));

	if (mil+uws+civs) {

	    *buf1 = '\0';
	    if (mil) sprintf(buf1,"%d mil",mil);
	    strcpy(buf,buf1);

	    *buf1 = '\0';
	    if (civs) sprintf(buf1,"%s%d civs",mil?", ":"",civs);
	    strcat(buf,buf1);

	    *buf1 = '\0';
	    if (uws) sprintf(buf1,"%s%d uws",(mil+civs)?", ":"",uws);
	    strcat(buf,buf1);
	    
	    wu(0, target->sct_own, 
	       fmt("%s strafing run killed %s in %s", cname(cnum), buf,
		   xyas(target->sct_x, target->sct_y, target->sct_own)));

	    nreport(cnum, N_POP_STRAFE, target->sct_own, 1);
	}

	shots++;
    next:
	;
    }
    return shots;
}

