#ifndef lint
static char *RCSid = "$Header: upgr.c,v 1.1 89/12/14 08:21:12 jay Exp $";
#endif /* not lint */

/*
 * upgr.c
 *
 * upgrade tech of ships.
 *
 * Dave Pare, 1986
 */

#include "misc.h"
#include "xy.h"
#include "var.h"
#include "ship.h"
#include "sect.h"
#include "nat.h"
#include "nsc.h"
#include "file.h"

upgr()
{
    extern	char *argp[];
    struct	sctstr sect;
    struct	natstr *natp;
    struct	nstr_item ni;
    struct	shpstr ship;
    struct	mchrstr *mp;
    int	upgradable,n;
    int	tlev;
    int	w_p_eff;
    int	points;
    
    if (!snxtitem(&ni,EF_SHIP, argp[1]))
	return RET_SYN;
    natp = getnatp(cnum);
    tlev = (int) natp->nat_level[NAT_TLEV];
    n = 0;
    while (nxtitem(&ni, (char *) &ship)) {
	
	getsect(ship.shp_x, ship.shp_y, &sect);
	if (!owner || sect.sct_effic < 60) continue;
	if (ship.shp_tech >= tlev) continue;
	if (ship.shp_depth > 0) continue;

	mp = &mchr[ship.shp_type];
	
	upgradable = 
	    stypeinlist(class[mp->m_class].birthplace,
			sect.sct_type);
	
	dpr(fmt("upgr: ship.shp_type = %d",ship.shp_type));
	dpr(fmt("      mp->m_class = %d",mp->m_class));
	dpr(fmt("      class[%d].birthplace = \"%s\"",
		mp->m_class,class[mp->m_class].birthplace));
	dpr(fmt("      sect.sct_type = %d",sect.sct_type));
	dpr(fmt("      upgradable = %d",upgradable));

	switch (mp->m_class) {
#ifdef NOTANKUPGRADES
	case CLASS_TANK:    upgradable = -1;
#endif
#ifdef NOTRAINUPGRADES
	case CLASS_TRAIN:   upgradable = -1;
#endif
#ifdef NOBALLOONUPGRADES
	case CLASS_BALLOON: upgradable = -1;
#endif
#ifdef NOSHIPUPGRADES
	case CLASS_SHIP:    upgradable = -1;
#endif
	default:	    break;
	}
	
	if (upgradable <= 0) {
	    pr(fmt("%s #%d can't be upgraded",
		   mp->m_name,ship.shp_uid));
	    if (upgradable==0)
		pr(fmt(" in a %s sector",
		       dchr[sect.sct_type].d_name));
	    pr(".\n");
	    continue;
	}
	
	n++;
	w_p_eff = ((mp->m_lcm / 2) + mp->m_hcm);
	points = sect.sct_avail * 100 / w_p_eff;
	if (points < 20) {
	    pr(fmt("Not enough available work in %s to upgrade a %s\n",
		   xyas(sect.sct_x, sect.sct_y, cnum),
		   mp->m_name));
	    pr(fmt(" (%d available work required)\n",
		   1 + (w_p_eff * 20)/100));
	    continue;
	}
	if (ship.shp_effic < 60) {
	    pr(fmt("%s #%d is too damaged to upgrade!\n",
		   mp->m_name, ship.shp_uid));
	    continue;
	}
	sect.sct_avail = (sect.sct_avail * 100 - w_p_eff * 20) / 100;
	ship.shp_effic -= 35;
	ship.shp_tech = tlev;
	putship(ship.shp_uid, &ship);
	putsect(&sect);
	dolcost += (double) mp->m_cost * .15;
    }
    if (n == 0) {
	pr("No upgrades\n");
	return RET_SYN;
    }
    return RET_OK;
}
