static char *RCSid = "$Header: empmod.c,v 1.1 89/12/14 13:26:37 jay Exp $";

/*
 * empmod.c
 *
 * Command/function mapping for empire.  Named empmod for historical
 * reasons -- empire used to be broken into seven modules
 * on the venerable pdp 11 so it could fit in 64k I/D space.
 *
 * from PSL Empire, 1985
 */

#include "misc.h"
#include "com.h"
#include "nat.h"
#include "tm.h"
#include "file.h"

extern	int  add();
extern	int assa();
extern	int atta();
extern	int boar();
extern	int bomb();
extern	int buil();
extern	int chan();
extern	int coas();
extern	int coll();
extern	int comm();
extern	int cons();
extern	int coun();
extern	int decl();
extern	int deli();
extern	int show();
extern	int desi();
extern	int diss();
extern	int drop();
extern	int enli();
extern	int fire();
extern	int flee();
extern	int  fly();
extern	int info();
extern	int ledg();
extern	int load();
extern	int look();
extern	int  map();
extern	int mine();
extern  int move();
extern	int nati();
extern	int navi();
extern  int head(), news();
extern	int nuke();
extern	int offe();
extern	int offs();
extern	int para();
extern	int path();
extern	int powe();
extern	int rada();
extern	int  rea();
extern	int real();
extern	int reco();
extern	int repa();
extern	int rout();
extern	int sona();

extern	int tele();
extern	int tend();
extern	int torp();
extern	int trad();
extern  int tran();
extern	int trea();
extern	int turn();
extern	int vers();
/*
 * new commands
 */
extern	int buy();
extern	int mult();
extern	int repo();
extern	int fina();
extern	int laun();
extern	int new();
extern	int shoo();
extern	int thre();
extern	int dist();
extern	int sct();
extern	int plan();
extern	int arm();
extern	int hard();
extern	int upgr();
extern	int surv();
extern	int capi();
extern	int orig();
extern	int mark();
extern	int conv();
extern  int leve();
extern	int cuto();
extern	int prod();
extern	int  wai();
extern	int carg();
extern	int terr();
extern	int sate();
extern	int give();
extern	int edit();
extern	int wipe();
extern	int dump();
extern	int expl();
extern	int reso();
extern	int scra();
extern	int rela();
extern	int brea();
extern	int upda();
extern	int hidd();
extern	int bmap();
extern	int orde();
extern	int adis();
extern	int tpath();
extern  int aboa();
extern  int driv();
extern  int ope();
extern  int clo();
extern  int bid();
extern  int ask();
extern  int dest();
extern  int crate();
extern  int uncrate();
extern  int scut();
extern  int view();
extern  int lotto();
extern  int swee();
extern  int sub();
extern	int recr();
extern	int name();
extern  int hunt();
extern  int kbomb();
extern  int convoy();
extern  int bal();
extern  int strafe();
extern  int snoop();
extern  int disown();
extern	int pnam();
extern  int elev();
extern  int enable();
extern  int disable();
#ifdef SPIES
extern	int  spy();
#endif

/*
 * Undeclared functions
 */
extern	int quit();
extern	int cens();
extern	int demo();
extern	int sell();
extern	int ship();
extern  int tank();
extern  int ball();
extern  int trai();
extern  int simatta();
extern	int wing();
extern	int execute();
extern	int explain();
extern	int  set();
extern  int vehi();

#define	SCT	bit(EF_SECTOR)
#define SHP	bit(EF_SHIP)
#define PLN	bit(EF_PLANE)
#define SPY	bit(EF_SPY)

struct  comstr  coms[]  = {
/* command syntax		                       cost lck   	addr  	permit */

"aboard <SHIPS|VEHICLES>",				0, SHP|PLN,	aboa,	NORM,
"add <NAT> <NAME> <REP> <STATUS> <c|w|i>",		0, SCT,	 	add,  	GOD,
"autodistribute <SECTS> <SECT> [list-of-types]",	1, SCT,		adis,	NORM,
"announce",						1, 0,		tele,	NORM,
#ifdef NUKES
#ifdef PLANES
"arm <PLANE> <NUKETYPE> <NUMBER>",         		3, SCT,		arm,	NORM+MONEY,
#endif
#endif
#ifdef TRADECENTERS
"ask <COMM> <tradecenter-SECT> <PRICE> [THRESH]",	0, 0,		ask,	NORM+CAP,
#endif
"assault <to-SECT> <from-SHIP|VEHICLE> <NUMBER>",	3, SCT|SHP,	assa,	NORM+MONEY,
"attack <SECT> <move-in-afterwards?>",			3, SCT,		atta,	NORM+MONEY+CAP,
#ifdef BALLOONS
"balloon <BALLOONS> [climb|descend]",			0, 0,		ball,	NORM,
#endif
#ifdef TRADECENTERS
"bid <COMM> <tradecenter-SECT> <PRICE> [THRESH]",	0, 0,		bid,	NORM+CAP+MONEY,
#endif
"bmap <SECTS>",						0, 0,		bmap,	SANCT,
"board <to-SHIP|VEHICLE> <from-SHIP|VEHICLE>",		3, SHP,		boar,	NORM+MONEY,
#ifdef PLANES
"bomb <bomber-PLANES> <fighter-PLANES> <pin|strat|nuke> <SECT> <FLIGHTPATH>",
                                                        2, SCT|SHP,	bomb,	NORM,
#endif
"break {sanctuary}",					1, 0,		brea,	SANCT,
"build <shi|nuk|bri|pla|tan|tra> <SECTS> <type|dir> <tech>",
                                                 	1, SHP|SCT,	buil,	NORM+MONEY+CAP,
#ifdef TRADECENTERS
"buy <onto-SHIP|VEHICLE> <NUM> <COMM>",			1, SHP|SCT,	load,	NORM,
#else
"buy <COMM> [<NAT> <NUM> <SECT>]",			1, SCT,		buy,	NORM+MONEY+CAP,
#endif
"bye {log-off}",					0, 0,		quit,	VIS,
"capitol <SECT>",					1, 0,		capi,	NORM,
"cargo <SHIPS|VEHICLES>",				0, 0,		carg,	NORM,
"census <SECTS>",					0, 0,		cens,	SANCT,
"change <country|representative> <NAME>",		0, 0,		chan,	SANCT,
#ifdef TRADECENTERS
"close <tradecenter-SECT> [to-NAT|*|.]",		1, 0,		clo,	NORM,
#endif
"coastwatch <SECTS>",					1, 0,		coas,	NORM,
"collect <LOAN> <SECT>",				2, 0,		coll,	NORM+CAP,
"commodity <SECTS>",					0, 0,		comm,	SANCT,
"consider <loan|treaty> <LOAN/TREATY> <acc|decl|post>",	1, 0,		cons,	NORM+CAP,
"convert <SECTS> <NUM>",				2, 0,		conv,	NORM+CAP,
"convoy <CONVOY> <SHIPS|VEHICLES>",			1, SHP,		convoy,	NORM,
"country <NATS>",					0, 0,		coun,	GOD,
"crate <PLANES>",                                     	1, SCT,		crate,	NORM+MONEY+CAP,
"cutoff <SECTS>",					0, 0,		cuto,	NORM,
"declare <all|neut|hos|war> <NAT>",			2, 0,		decl,	NORM,
"deliver <COMM> <SECTS> <DIR> <[+|-]thresh>",		1, SCT,		deli,	NORM,
"demobilize <SECTS> <NUM> <active-reserve?>",		1, SCT,		demo,	NORM+MONEY,
"designate <SECTS> <type>",				1, SCT,		desi,	NORM,
"destroy <SHIP|VEHICLE>",                               0, SHP,         dest,   GOD,
"disable",						0, 0,           disable, GOD,
"disown <SECTS> <really?>",				0, SCT,         disown, NORM,
"dissolve <really?>",					0, SCT|SHP,	diss,	NORM,
"distribute <COMMODITY> <SECTS> <PATH>",		1, SCT,		dist,	NORM,
#ifdef PLANES
"drop <cargo-PLANES> <fighter-PLANES> <SECT> <FLIGHTPATH> <COMM>",
                                                        1, SCT,		drop,	NORM,
#endif
"dump <SECTS>",						0, 0,		dump,	SANCT,
"edit <country|land|ship|plane|balloon|tank|train>",	0, 0,		edit,	GOD,
"elevation <SECTS> [list]",				0, 0,		elev,   SANCT,
"enable",						0, 0,           enable, NORM,
"enlist <SECTS> <NUM>",					2, SCT,		enli,	NORM+MONEY+CAP,
"execute <INPUT FILE>",					0, 0,		execute,SANCT,
"explore <c|m> <SECT> <NUM> <PATH>",			1, SCT,		expl,	NORM+CAP,
"financial",						1, 0,		fina,	NORM+MONEY,
"fire <target-SECT|SHIP|VEHICLE> <from-SECT|SHIP|VEHICLE> [GUNS]",	
                                                        1, SCT|SHP,	fire,	NORM+MONEY,
"fleetadd <FLEET> <SHIPS|VEHICLES>",			1, SHP,		flee,	NORM,
#ifdef PLANES
"fly <cargo-PLANES> <fighter-PLANES> <SECT> <FLIGHTPATH> <COMM>",
		                                        2, SCT|SHP,	fly,	NORM,
#endif
"give <SECT> [<[-]NUM> <COMM>]...",			0, 0,		give,	GOD,
#ifdef PLANES
"harden <PLANES> <NUM>",				2, SCT,		hard,	NORM+MONEY,
#endif
"headlines [days] [p<page>]",				0, 0,		head,	VIS,
"hidden <SECTS>",					0, 0,		hidd,	GOD,
"hunt <SECTS> <SPY|\"*\"> [capture|kill|none]",		1, SPY,		hunt,   NORM+CAP+MONEY,
"info <topic>",						0, 0,		info,	VIS,
#ifdef PLANES
"kbomb <bomber-PLANES> <fighter-PLANES> <pin|strat|nuke> <SECT> <FLIGHTPATH> <K-target>",
                                                        2, SCT|SHP,	kbomb,	NORM,
#endif
#ifdef PLANES
"launch <PLANES>",					3, SCT|SHP,	laun,	NORM+MONEY,
#endif
"ledger <LOANS>",					0, 0,		ledg,	NORM,
"level <SECTS>",					0, 0,		leve,	NORM,
"list of commands",					0, 0,		explain,VIS,
"load <onto-SHIPS|VEHICLES> <QTY|PLN#|TNK#> <COMM|\"plane\"|\"tank\">",
                                                        1, SHP|SCT,	load,	NORM,
"lookout <SHIPS|VEHICLES>",				1, 0,		look,	NORM,
#ifdef LOTTERY
"lotto <\"list\"|\"jackpot\"|\"sales\"|\"quick\"|[NUMBERS...]>",0,0,    lotto,  NORM,
#endif
#ifdef TRADECENTERS
"market <SECT|NAT|*|.> [COMMLIST]",			0, 0,		mark,	NORM,
#else
"market [COMM]",					0, 0,		mark,	NORM,
#endif
"map <SECTS>",						0, 0,		map,	SANCT,
"mine <SHIPS>",						2, SCT|SHP,	mine,	NORM+MONEY,
"move <COMM> <SECT> <NUM> <PATH>",			1, SCT,		move,	NORM+CAP,
"mult [COUNTRY]",					1, 0,		mult,	NORM,
"name <ship|tank|train|balloon|spy> <ID> <NAME>",	0, 0,		name,
 NORM,
"nation",						0, 0,		nati,	SANCT,
"navigate <SHIPS|VEHICLES> <PATH>",			1, SHP,		navi,	NORM,
"newcap <NAT>",						0, SCT,		new,	GOD,
"newspaper [days] [p<PAGE>]",				0, 0,		news,	VIS,
#ifdef NUKES
"nuke <NUKES>",						0, 0,		nuke,	NORM+CAP,
#endif
"offer <loan|treaty> <NAT> [<NUM> <DAYS> <IRATE>]",	1, 0,		offe,	NORM,
"offset <SECT|NAT>",					0, 0,		offs,	GOD,
#ifdef TRADECENTERS
"open <tradecenter-SECT> <to-NAT|*|.> <MULTIPLIER>",	1, 0,		ope,	NORM,
#endif
"order <SHIPS|VEHICLES> [<cancel|standby|resume|eta|to-SECT>]",
                                                	1, SHP,		orde,	NORM+CAP,
"origin <SECT>",					1, 0,		orig,	NORM,
#ifdef PLANES
"paradrop <cargo-PLANES> <fighter-PLANES> <SECT> <FLIGHTPATH>",
                                        		3, SCT,		para,	NORM,
#endif
"path <SECT>",						0, 0,		path,	NORM,
#ifdef PLANES
"plane <SECTS>",					0, 0,		plan,	NORM,
#endif
"pname [create|list|delete] <PATHNAME> <PATH>",		0, 0,		pnam,
 NORM,
"power [\"new\"]",					0, 0,		powe,	VIS,
"production <SECTS>",					0, 0,		prod,	NORM,
"quit",							0, 0,		quit,	VIS,
"radar <SECTS|SHIPS|VEHICLES>",				1, 0,		rada,	NORM,
"read",							0, 0,		rea,	VIS,
"realm <number> [<SECTS>]",				0, 0,		real,	SANCT,
#ifdef PLANES
"recon <spy-PLANES> <fighter-PLANES> <SECT> <FLIGHTPATH>",
                                          		3, 0,		reco,	NORM,
#endif
#ifdef SPIES
"recruit <SECTS> <type>",                		1, SPY|SCT,	recr,	NORM+MONEY+CAP,
#endif
"relations  [as-COUNTRY]",				0, 0,		rela,	SANCT,
"repay <LOAN> <NUM>",					1, 0,		repa,	NORM,
"report <NATS>",					0, 0,		repo,	VIS,
"resource <SECTS>",					0, 0,		reso,	SANCT,
"route <COMM> <SECTS>",					1, 0,		rout,	NORM+CAP,
"satellite <SATELLITES|SECTS> [blmpst]",		1, 0,		sate,	NORM,
"scrap <TYPE> <SHIPS|PLANES|VEHICLES>",			2, SHP,		scra,	NORM+MONEY,
"scuttle <SHIPS>",                                      2, SHP,         scut,   NORM,
"sect <SECTS>",						0, 0,		sct,	NORM,
#ifdef TRADECENTERS
"sell <from-SHIP|VEHICLE> <NUM> <COMM>",		1, SHP|SCT,	load,	NORM,
#else
"sell <COMM> <SECTS> <NUM> <NUM>",			1, SCT,		sell,	NORM,
#endif
"set <TYPE> <LIST> <PRICE>",				1, SHP,		set,	NORM,
"ship <SHIPS>",						0, 0,		ship,	NORM,
"shoot <SECTS> <NUMBER>",				3, SCT,		shoo,	NORM+CAP,
"show <TYPE|\"blast\"> <\"build\"|\"cap\"|NUKETYPE>",	0, 0,		show,	VIS,
"simattack <SECT> <def-MIL> <def-EFFIC>",		0, SCT,	     	simatta,NORM,
"snoop <SECTS>",					1, 0,		snoop,	NORM+CAP,
"sonar <SHIPS>",					1, 0,		sona,	NORM,
"spy <SPIES> [function [args...]]",			1, 0,		spy,	NORM+CAP,
"strafe <PLANES> <SECT> <FLIGHTPATH>",	                2, SCT|SHP,	strafe,	NORM,
"sub <SUBMARINES> [surf|peri|deep]",			0, 0,		sub,	NORM,
"survey <COMM|VAR> <SECTS>",				0, 0,		surv,	NORM+CAP,
#ifdef PLANES
"sweep <HELICOPTERS> <ESCORTS> <SECT> <FLIGHTPATH>",
                                          		3, 0,		swee,	NORM,
#endif
#ifdef TANKS
"tank <TANKS>",						0, 0,		tank,	NORM,
#endif
"telegram <NAT>",					0, 0,		tele,	NORM,
"tend <tender-SHIP> <COMM> <NUM> <receiver-SHIP>",	1, SHP,		tend,	NORM+MONEY,
"territory <SECTS> <NUMBER>",				1, SCT,		terr,	NORM,
"test <COMM> <SECT> <NUM> <PATH>",			1, SCT,		move,	NORM+CAP,
"threshold <COMM> <SECTS> <THRESH>",			1, SCT,		thre,	NORM,
"torpedo <target-SHIP> <submarine-SHIP>",		3, SHP,		torp,	NORM+MONEY,
"tpath <SECTS> <SECT> [list-of-types]",			0, SCT,		tpath,	NORM,
"trade",						1, SHP,		trad,	NORM,
"train <TRAINS>",					0, 0,		trai,	NORM,
"transport <\"nuke\"|\"plane\"|\"tank\"> <NUKES|PLANES|TANKS> [nuketype] <PATH>",
                                                        1, SCT|SHP,	tran,	NORM+CAP,
"treaty <TREATIES>",					0, 0,		trea,	NORM,
"turn <\"on\"|\"off\"|\"mess\">",			0, 0,		turn,	GOD,
"uncrate <PLANES>",                                    	1, SCT,		uncrate,NORM+MONEY+CAP,
"unload <from-SHIPS|VEHICLES> <NUM> <COMM|\"plane\"|\"tank\">",
                                                        1, SHP|SCT,	load,	NORM,
"update",						0, 0,		upda,	VIS,
"upgrade <SHIPS|VEHICLES>",				1, SHP,		upgr,	NORM+MONEY,
"vehicle <SHIPS|VEHICLES>",				0, 0,		vehi,	NORM,
"view <SECT> [blmpst]",					0, 0,		view,	GOD,
"version",						0, 0,		vers,	VIS,
"wait",							0, 0,		wai,	SANCT,
#ifdef PLANES
"wingadd <WING> <PLANES>",				1, PLN,		wing,	NORM,
#endif
"wipe <SECTS>",						1, SCT,		wipe,	NORM,
0,							0, 0,		0,	0,
};
