static char *RCSid = "$Header: signals.c,v 1.1 89/12/14 13:26:43 jay Exp $";

/*
 * signals.c
 *
 * handle out of band messages
 *
 * Dave Pare, 1986
 */

#include "proto.h"
#include "misc.h"

#include <stdio.h>
#include <signal.h>

/*
 * SIGHUP is recieved when server wants to break lock on
 * a particular empire process.  Kind of scary...who knows
 * what system calls might be interrupted here.
 */
hup()
{
	extern	int aborted;

	pr("\nServer broke lock.\n");
	aborted = 1;
#ifdef sys5
	(void) signal(SIGHUP, hup);
#endif
}

/*
 * gencore lets the player know empire puked, then drops a core
 * in the empire home directory.
 *
 * I won't natter about how this should never happen...
 */
gencore(sig)
	int	sig;
{
	(void) signal(SIGILL, SIG_DFL);
	(void) signal(SIGIOT, SIG_DFL);
	pr("\n");
	outid(C_EXIT);
	pr(fmt("Empire died on signal %d!\n", sig));
	(void) fflush(stdout);
	_cleanup();
	abort();
}

killoff(sig)
{
    (void) signal(SIGILL, SIG_DFL);
    (void) signal(SIGIOT, SIG_DFL);
    pr("(quit)\n");
    quit();
}

sigsetup()
{
	(void) signal(SIGPIPE, SIG_IGN);
	(void) signal(SIGHUP, hup);
	(void) signal(SIGFPE, gencore);
	(void) signal(SIGILL, gencore);
	(void) signal(SIGBUS, gencore);
	(void) signal(SIGSEGV, gencore);
	(void) signal(SIGQUIT, killoff);
}
