#ifndef lint
static char *RCSid = "$Header: plane.c,v 1.1 89/12/14 13:28:29 jay Exp $";
#endif

/*
 * plane.c
 *
 * plane post-read and pre-write
 *
 * Dave Pare, 1989
 */

#include "misc.h"
#include "var.h"
#include "plane.h"
#include "ship.h"
#include "xy.h"
#include "file.h"
#include "nat.h"
#include "deity.h"

int pln_postread(n, ptr)
int n;
char *ptr;
{
    struct plnstr *pp = (struct plnstr *) ptr;
    struct shpstr theship;
    char *p;
    int kill;
    
    if ((pp->pln_ship >= 0) && pp->pln_own && (pp->pln_effic >= 10)) {
	if (kill=(!getship(pp->pln_ship, &theship))) 
	    pr("Ship doesn't exist");
	else if (kill=(theship.shp_effic < 20)) 
	    pr("Ship no longer exists");
	else if (pp->pln_flags & PLN_BOXED) {
	    if (kill=(!(mchr[theship.shp_type].m_flags & M_TAC)))
		pr("Ship not a transport");
	} else {
	    if (kill=(!planefitsship(plchr[pp->pln_type].pl_flags,
				     mchr[theship.shp_type].m_flags)))
		pr("Incompatible ship");
	}
	if (kill) {
	    p = fmt(" - %s #%d sunk!\n", plchr[pp->pln_type].pl_name,n);
	    /* yes, sunk */
	    if (pp->pln_own && (pp->pln_own != cnum))
		wu(0, pp->pln_own, p);
	    pr(p);
	    pp->pln_own = 0;
	    (void) ef_nbwrite(EF_PLANE, n, ptr);
	} else {
	    pp->pln_x = xnorm(theship.shp_x);
	    pp->pln_y = ynorm(theship.shp_y);
	}
    }
    owner = (god || (pp->pln_own == cnum));
    dpr(fmt("pln_postread: %s #%d @ %s own=%d ship=%d",
	    plchr[pp->pln_type].pl_name,
	    pp->pln_uid, xyas(pp->pln_x,pp->pln_y,cnum),
	    pp->pln_own, pp->pln_ship));
    return 1;
}

/*ARGSUSED*/
int pln_prewrite(n, ptr)
int n;
char *ptr;
{
    struct	plnstr *pp = (struct plnstr *) ptr;
    if (pp->pln_effic < 10) 
	pp->pln_own = 0;
    else {
	pp->pln_x = xnorm(pp->pln_x);
	pp->pln_y = ynorm(pp->pln_y);
    }
    return 1;
}
