#ifndef lint
static char *RCSid = "$Header: wu.c,v 1.1 89/12/14 13:30:57 jay Exp $";
#endif

/*
 * wu.c
 *
 * server in-memory version of wu.
 * has one long "production" telegram
 *
 * from PSL Empire, 1985
 */

#include "misc.h"
#include "news.h"
#include "tel.h"
#include "nat.h"
#include "file.h"

#include <stdio.h>
#include <fcntl.h>

struct msg {
	struct msg *m_next;
	int m_len;
	char *m_text;
};

struct	msg *msgs[MAXNOC];
struct	msg *msgs_tail[MAXNOC];

/*
**  pr() - server in-memory version of pr()
*/

pr()
{
    /* dummy routine */
}

/*
**  prc() - server in-memory version of prc()
*/

prc(c1,text)
natid c1;
char *text;
{
    wu(0,c1,text);
}

/*
**  prcc() - server in-memory version of prcc()
*/

prcc(c1,c2,text)
natid c1,c2;
char *text;
{
    wu(0,c1,text);
    if (c1 != c2) wu(0,c2,text);
}

/*
**  Ignore "from" field
**  It is there for historical reasons
*/

wu(from, to, text)
natid from,to;
char *text;
{
    struct	msg *mp;
    
    mp = (struct msg *) malloc(sizeof(struct msg));
    mp->m_next = 0;
    mp->m_len = strlen(text);
    mp->m_text = strcpy(malloc((unsigned)mp->m_len+1), text);
    if (msgs_tail[to] == 0)
	msgs[to] = mp;
    else
	msgs_tail[to]->m_next = mp;
    msgs_tail[to] = mp;
}

flushwu()
{
    register struct msg *mp;
    register struct msg *next;
    register int len;
    struct	telstr t;
    natid	i;
    FILE	*fp;
    long	now;
    
    (void) time(&now);
    for (i=0; getnatp(i) != 0; i++) {
	if (msgs[i] == 0)
	    continue;
	t.tel_from = 0;
	t.tel_date = now;
	t.tel_type = TEL_UPDATE;
	t.tel_length = 0;
	len = 0;
	for (mp = msgs[i]; mp != 0; mp = mp->m_next)
	    len += mp->m_len;
	t.tel_length = len;
	if (len <= 0)
	    continue;
	if ((fp = fopen(mailbox(i), "a+")) == 0) {
	    logerror("cannot open mailbox %s", mailbox(i));
	    continue;
	}
	file_lock(fileno(fp));
	(void) fwrite((char *)&t, sizeof(t), 1, fp);
	for (mp = msgs[i]; mp != 0; mp = next) {
	    next = mp->m_next;
	    fputs(mp->m_text, fp);
	    free((char *)mp->m_text);
	    free((char *)mp);
	}
	(void) fflush(fp);
	file_unlock(fileno(fp));
	(void) fclose(fp);
	msgs[i] = 0;
	NAT_DELTA(nat_tgms, i, 1);
    }
}
