/*
 * misc.h
 *
 * defines which don't really belong anywhere,
 * but have to go somewhere!
 *
 * $Revision: 1.1 $ $Date: 89/12/12 17:00:20 $
 */

#include <sys/types.h>

#ifdef hpux
#include <string.h>
#else
#include <strings.h>
#endif

/* ________________________________________________________________
**|                                                                |
**| World size and maximum number of countries                     |
**|________________________________________________________________|
*/

#define MAXNOC		16
#define WORLD_X		256
#define WORLD_Y		128

/* ________________________________________________________________
**|                                                                |
**| Define which features you want compiled into the game;         |
**| comment out the features you don't want to include.            |
**|________________________________________________________________|
*/

#define LOTTERY			/* include POGOLOTTO */
#define SPIES			/* game includes spies */

/* Vehicle options */

#define PLANES			/* game includes planes */
#define NUKES			/* game includes nukes */
#define TANKS			/* game includes tanks */
#define BALLOONS		/* game includes balloons */
#define TRAINS		        /* game includes trains */
#define SHIPSNEEDPET		/* ships need petrol to move */

/* Market/Trade options */

#define TRADECENTERS		/* use trade centers instead of telemarket */
#define TRADECENTERISAIRPORT    /* can fly in and out of trade centers */
#define TRADEONLYINCENTERS	/* TRADE works only in trade centers, but: */
/*#define TELEPORTPLANES	/* teleport plane & nuke sales */
/*#define TRADESHIPSANYWHERE	/*   ships can be traded anywhere */
/*#define TRADETANKSANYWHERE	/*   tanks can be traded anywhere */
/*#define TRADEBALLOONSANYWHERE	/*   balloons can be traded anywhere */
/*#define TRADETRAINSANYWHERE	/*   trains can be traded anywhere */
/*#define TRADEPLANESANYWHERE	/*   planes can be traded anywhere */
/*#define TRADENUKESANYWHERE	/*   nukes can be traded anywhere */

/* Flight options */

#define ASSEMBLEANYWHERE        /* don't have to own assembly point */
#define USEALLIEDCARRIERS       /* can land on allied carriers */
/* #define USENEUTRALCARRIERS      /* can land on neutral carriers */
#define USEALLIEDAIRPORTS       /* can land in allied airports */
/* #define USENEUTRALAIRPORTS      /* can land in neutral airports */
/* #define USEHOSTILEAIRPORTS      /* can land in hostile airports */
/* #define USEENEMYAIRPORTS        /* can land in enemy (at war) airports */
#define DROPANY			/* 'airdrop' drops into anyone's sector */

/* Intercept mission options */

/* #define ALLIEDENCOUNTERS	/* encounter allied aircraft */
#define NEUTRALENCOUNTERS	/* encounter neutral aircraft */
#define HOSTILEENCOUNTERS	/* encounter hostile aircraft */
#define WARENCOUNTERS		/* encounter at-war aircraft */

/* Deliver/Distribute options */

#define DELIVERPEOPLE		/* 'deliver' works with civs & mil */
#define DISTRIBUTEPEOPLE	/* 'dist' & 'thresh' work with civs & mil */

/* Warfare options */

#define ANYCANFIRE		/* any sector with guns/shells/mil can fire */
/* #define ATTACKBTUS		/* attacker pays 0.15 btu/defender loss */
/* #define ASSAULTBTUS		/* assaulter pays 0.15 btu/defender loss */
#define BUNKERS                 /* game includes bunkers */
#define NEUTRONBOMBS		/* include neutron bombs in the nuke list */
#define GUNTECH        10	/* (20) tech needed to build guns */
#define SHELLTECH      10	/* (20) tech needed to build shells */

/* #define COASTWATCHRADAR	/* radar has 3.5x coastwatch range */

/* ________________________________________________________________
**|                                                                |
**| The maximum size of the trade center file is set by            |
**| the following define.                                          |
**|________________________________________________________________|
*/

#define MAXTRADECENTERS MAXNOC*25	/* trade center file size limit */

/*  _______________________________________________________________ 
** |_______________________________________________________________|
*/

typedef u_char natid;		/* also change NSC_NATID in nsc.h */
typedef	short coord;		/* also change NSC_COORD in nsc.h */

/*
 * watch it; your compiler might not like this.
 * If you think this is bogus, look at /usr/include/struct.h
 */
#define	OFFSET(stype, oset) ((int)(&(((struct stype *)0)->oset)))
#define	SETOFF(sinst, oset) ((char *) (sinst) + (oset))

#ifndef bit
#define	bit(x)		(1<<(x))
#endif

#define minutes(x)	(60*(x))
#define hours(x)	(60*60*(x))
#define days(x)		(60*60*24*(x))

typedef void (*voidfunc)();

	/* return codes from command routines */
#define	RET_OK		0   /* command completed sucessfully */
#define	RET_FAIL	1   /* command completed unsucessfully [?] */
#define	RET_SYN		2   /* syntax error in command */
#define	RET_SYS		3   /* system error (missing file, etc) */

/*
 * references to library functions which aren't related to any
 * particular object, and are of general interest
 */
extern	long random();

extern	double dmax();
extern	double dmin();

extern	char *fmt(/* char * */);
extern	char *copy();
extern	char *numstr();
extern	char *esplur();
extern	char *splur();
extern	char *iesplur();
extern	char *plur();
extern	char *getstarg();
extern	char *getstring();

/*
 * frequently used libc functions
 */

extern	char *malloc();
extern	char *calloc();

extern	char *ctime();
extern	char *strncpy();
extern	char *strcpy();
extern	char *index();
extern	char *rindex();

extern	time_t time();
extern	double atof();
